[

// ********************************************************************************************** //
// * PLAYERS                                                                                    * //
// ********************************************************************************************** //

{"Entity": "Keen",
    "Components": [
        {"Component": "Location", "Properties": {
            "width": 8,
            "height": 32
        }},
        {"Component": "Collidable"},
        {"Component": "Velocity", "Properties": {
            "vxMax": 140,
            "vyMax": 380
        }},
        {"Component": "GravityClipped"},
        {"Component": "TileSensor"},
        {"Component": "PhysicalPlatform"},
        {"Component": "Visible", "Properties": {
            "lib": "keen",
            "frame": "stand_left",
            "layer": 2
        }},
        {"Component": "ItemCollector"},
        {"Component": "Activator"},
        {"Component": "KeenBehavior"}
    ]
},

{"Entity": "LittleKeen",
    "Components": [
        {"Component": "Location", "Properties": {
            "width": 16,
            "height": 16
        }},
        {"Component": "Collidable"},
        {"Component": "Velocity", "Properties": {
            "vxMax": 500,
            "vyMax": 500
        }},
        {"Component": "ZeroGClipped"},
        {"Component": "Physical", "Properties": {
            "gravity": 0,
            "frictionX": 700,
            "frictionY": 700
        }},
        {"Component": "Visible", "Properties": {
            "lib": "keen",
            "frame": "map_walk_left1",
            "layer": 2
        }},
        {"Component": "Activator"},
        {"Component": "LittleKeenBehavior"}
    ]
},

// ********************************************************************************************** //
// * ITEMS                                                                                      * //
// ********************************************************************************************** //

{"Entity": "BlueGem",
    "Components": [
        {"Component": "Location", "Properties": {
            "width": 15,
            "height": 12
        }},
        {"Component": "Collidable"},
        {"Component": "Visible", "Properties": {
            "lib": "items",
            "frame": "gemblue1",
            "layer": 2
        }},
        {"Component": "Animation", "Properties": {
            "looped": true,
            "global": true,
            "delay": 260,
            "frames": ["gemblue1", "gemblue2"]
        }},
        {"Component": "Item", "Properties": {
            "name": "blueGem",
            "amount": 1
        }},
        {"Component": "SpawnOnDestruct", "Properties": {
            "template": "CollectGem"
        }}
    ],
    "Attributes": {
        "gridsnap": true
    }
},

{"Entity": "Candybar",
    "Components": [
        {"Component": "Location", "Properties": {
            "width": 16,
            "height": 16
        }},
        {"Component": "Collidable"},
        {"Component": "Visible", "Properties": {
            "lib": "items",
            "frame": "candybar1",
            "layer": 2
        }},
        {"Component": "Animation", "Properties": {
            "looped": true,
            "global": true,
            "delay": 260,
            "frames": ["candybar1", "candybar2"]
        }},
        {"Component": "Item", "Properties": {
            "name": "points",
            "amount": 500
        }},
        {"Component": "SpawnOnDestruct", "Properties": {
            "template": "Points500"
        }}
    ],
    "Attributes": {
        "gridsnap": true
    }
},

{"Entity": "Donut",
    "Components": [
        {"Component": "Location", "Properties": {
            "width": 15,
            "height": 15
        }},
        {"Component": "Collidable"},
        {"Component": "Visible", "Properties": {
            "lib": "items",
            "frame": "donut1",
            "layer": 2
        }},
        {"Component": "Animation", "Properties": {
            "looped": true,
            "global": true,
            "delay": 260,
            "frames": ["donut1", "donut2"]
        }},
        {"Component": "Item", "Properties": {
            "name": "points",
            "amount": 2000
        }},
        {"Component": "SpawnOnDestruct", "Properties": {
            "template": "Points2000"
        }}
    ],
    "Attributes": {
        "gridsnap": true
    }
},

{"Entity": "Drop",
    "Components": [
        {"Component": "Location", "Properties": {
            "width": 16,
            "height": 16
        }},
        {"Component": "Collidable"},
        {"Component": "Visible", "Properties": {
            "lib": "items",
            "frame": "drop1",
            "layer": 2
        }},
        {"Component": "Animation", "Properties": {
            "looped": true,
            "global": true,
            "delay": 130,
            "frames": ["drop1", "drop2", "drop3", "drop4"]
        }},
        {"Component": "Item", "Properties": {
            "name": "drops",
            "amount": 1
        }},
        {"Component": "SpawnOnDestruct", "Properties": {
            "template": "CollectDrop"
        }}
    ],
    "Attributes": {
        "gridsnap": true
    }
},

{"Entity": "Flask",
    "Components": [
        {"Component": "Location", "Properties": {
            "width": 11,
            "height": 15
        }},
        {"Component": "Collidable"},
        {"Component": "Visible", "Properties": {
            "lib": "items",
            "frame": "flask1",
            "layer": 2
        }},
        {"Component": "Animation", "Properties": {
            "looped": true,
            "global": true,
            "delay": 260,
            "frames": ["flask1", "flask2"]
        }},
        {"Component": "Item", "Properties": {
            "name": "drops",
            "amount": 100
        }},
        {"Component": "SpawnOnDestruct", "Properties": {
            "template": "Yellow1Up"
        }}
    ],
    "Attributes": {
        "gridsnap": true
    }
},

{"Entity": "GreenGem",
    "Components": [
        {"Component": "Location", "Properties": {
            "width": 15,
            "height": 12
        }},
        {"Component": "Collidable"},
        {"Component": "Visible", "Properties": {
            "lib": "items",
            "frame": "gemgreen1",
            "layer": 2
        }},
        {"Component": "Animation", "Properties": {
            "looped": true,
            "global": true,
            "delay": 260,
            "frames": ["gemgreen1", "gemgreen2"]
        }},
        {"Component": "Item", "Properties": {
            "name": "greenGem",
            "amount": 1
        }},
        {"Component": "SpawnOnDestruct", "Properties": {
            "template": "CollectGem"
        }}
    ],
    "Attributes": {
        "gridsnap": true
    }
},

{"Entity": "Gum",
    "Components": [
        {"Component": "Location", "Properties": {
            "width": 16,
            "height": 16
        }},
        {"Component": "Collidable"},
        {"Component": "Visible", "Properties": {
            "lib": "items",
            "frame": "gum1",
            "layer": 2
        }},
        {"Component": "Animation", "Properties": {
            "looped": true,
            "global": true,
            "delay": 260,
            "frames": ["gum1", "gum2"]
        }},
        {"Component": "Item", "Properties": {
            "name": "points",
            "amount": 200
        }},
        {"Component": "SpawnOnDestruct", "Properties": {
            "template": "Points200"
        }}
    ],
    "Attributes": {
        "gridsnap": true
    }
},

{"Entity": "Icecream",
    "Components": [
        {"Component": "Location", "Properties": {
            "width": 10,
            "height": 16
        }},
        {"Component": "Collidable"},
        {"Component": "Visible", "Properties": {
            "lib": "items",
            "frame": "icecream1",
            "layer": 2
        }},
        {"Component": "Animation", "Properties": {
            "looped": true,
            "global": true,
            "delay": 260,
            "frames": ["icecream1", "icecream2"]
        }},
        {"Component": "Item", "Properties": {
            "name": "points",
            "amount": 5000
        }},
        {"Component": "SpawnOnDestruct", "Properties": {
            "template": "Points5000"
        }}
    ],
    "Attributes": {
        "gridsnap": true
    }
},

{"Entity": "Jawbreaker",
    "Components": [
        {"Component": "Location", "Properties": {
            "width": 15,
            "height": 15
        }},
        {"Component": "Collidable"},
        {"Component": "Visible", "Properties": {
            "lib": "items",
            "frame": "jawbreaker1",
            "layer": 2
        }},
        {"Component": "Animation", "Properties": {
            "looped": true,
            "global": true,
            "delay": 260,
            "frames": ["jawbreaker1", "jawbreaker2"]
        }},
        {"Component": "Item", "Properties": {
            "name": "points",
            "amount": 1000
        }},
        {"Component": "SpawnOnDestruct", "Properties": {
            "template": "Points1000"
        }}
    ],
    "Attributes": {
        "gridsnap": true
    }
},

{"Entity": "RedGem",
    "Components": [
        {"Component": "Location", "Properties": {
            "width": 15,
            "height": 12
        }},
        {"Component": "Collidable"},
        {"Component": "Visible", "Properties": {
            "lib": "items",
            "frame": "gemred1",
            "layer": 2
        }},
        {"Component": "Animation", "Properties": {
            "looped": true,
            "global": true,
            "delay": 260,
            "frames": ["gemred1", "gemred2"]
        }},
        {"Component": "Item", "Properties": {
            "name": "redGem",
            "amount": 1
        }},
        {"Component": "SpawnOnDestruct", "Properties": {
            "template": "CollectGem"
        }}
    ],
    "Attributes": {
        "gridsnap": true
    }
},

{"Entity": "Soda",
    "Components": [
        {"Component": "Location", "Properties": {
            "width": 10,
            "height": 16
        }},
        {"Component": "Collidable"},
        {"Component": "Visible", "Properties": {
            "lib": "items",
            "frame": "soda1",
            "layer": 2
        }},
        {"Component": "Animation", "Properties": {
            "looped": true,
            "global": true,
            "delay": 260,
            "frames": ["soda1", "soda2"]
        }},
        {"Component": "Item", "Properties": {
            "name": "points",
            "amount": 100
        }},
        {"Component": "SpawnOnDestruct", "Properties": {
            "template": "Points100"
        }}
    ],
    "Attributes": {
        "gridsnap": true
    }
},

{"Entity": "Stunner",
    "Components": [
        {"Component": "Location", "Properties": {
            "width": 15,
            "height": 11
        }},
        {"Component": "Collidable"},
        {"Component": "Visible", "Properties": {
            "lib": "items",
            "frame": "gun1",
            "layer": 2
        }},
        {"Component": "Animation", "Properties": {
            "looped": true,
            "global": true,
            "delay": 260,
            "frames": ["gun1", "gun2"]
        }},
        {"Component": "Item", "Properties": {
            "name": "ammo",
            "amount": 5
        }},
        {"Component": "SpawnOnDestruct", "Properties": {
            "template": "CollectStunner"
        }}
    ],
    "Attributes": {
        "gridsnap": true
    }
},

{"Entity": "YellowGem",
    "Components": [
        {"Component": "Location", "Properties": {
            "width": 15,
            "height": 12
        }},
        {"Component": "Collidable"},
        {"Component": "Visible", "Properties": {
            "lib": "items",
            "frame": "gemyellow1",
            "layer": 2
        }},
        {"Component": "Animation", "Properties": {
            "looped": true,
            "global": true,
            "delay": 260,
            "frames": ["gemyellow1", "gemyellow2"]
        }},
        {"Component": "Item", "Properties": {
            "name": "yellowGem",
            "amount": 1
        }},
        {"Component": "SpawnOnDestruct", "Properties": {
            "template": "CollectGem"
        }}
    ],
    "Attributes": {
        "gridsnap": true
    }
},

{"Entity": "Points100",
    "Components": [
        {"Component": "Location", "Properties": {
            "width": 0,
            "height": 0
        }},
        {"Component": "Velocity", "Properties": {
            "vx": 0,
            "vy": -40
        }},
        {"Component": "Visible", "Properties": {
            "lib": "sprites",
            "frame": "100points",
            "layer": 3
        }},
        {"Component": "SelfDestructing", "Properties": {
            "delay": 600 // ms
        }},
        {"Component": "OnSpawned", "Properties": {
            "OnSpawned": function() engine::PlaySound("get_points"); end function
        }}
    ]
},

{"Entity": "Points200",
    "Components": [
        {"Component": "Location", "Properties": {
            "width": 0,
            "height": 0
        }},
        {"Component": "Velocity", "Properties": {
            "vx": 0,
            "vy": -40
        }},
        {"Component": "Visible", "Properties": {
            "lib": "sprites",
            "frame": "200points",
            "layer": 3
        }},
        {"Component": "SelfDestructing", "Properties": {
            "delay": 600 // ms
        }},
        {"Component": "OnSpawned", "Properties": {
            "OnSpawned": function() engine::PlaySound("get_points"); end function
        }}
    ]
},

{"Entity": "Points500",
    "Components": [
        {"Component": "Location", "Properties": {
            "width": 0,
            "height": 0
        }},
        {"Component": "Velocity", "Properties": {
            "vx": 0,
            "vy": -40
        }},
        {"Component": "Visible", "Properties": {
            "lib": "sprites",
            "frame": "500points",
            "layer": 3
        }},
        {"Component": "SelfDestructing", "Properties": {
            "delay": 600 // ms
        }},
        {"Component": "OnSpawned", "Properties": {
            "OnSpawned": function() engine::PlaySound("get_points"); end function
        }}
    ]
},

{"Entity": "Points1000",
    "Components": [
        {"Component": "Location", "Properties": {
            "width": 0,
            "height": 0
        }},
        {"Component": "Velocity", "Properties": {
            "vx": 0,
            "vy": -40
        }},
        {"Component": "Visible", "Properties": {
            "lib": "sprites",
            "frame": "1000points",
            "layer": 3
        }},
        {"Component": "SelfDestructing", "Properties": {
            "delay": 600 // ms
        }},
        {"Component": "OnSpawned", "Properties": {
            "OnSpawned": function() engine::PlaySound("get_points"); end function
        }}
    ]
},

{"Entity": "Points2000",
    "Components": [
        {"Component": "Location", "Properties": {
            "width": 0,
            "height": 0
        }},
        {"Component": "Velocity", "Properties": {
            "vx": 0,
            "vy": -40
        }},
        {"Component": "Visible", "Properties": {
            "lib": "sprites",
            "frame": "2000points",
            "layer": 3
        }},
        {"Component": "SelfDestructing", "Properties": {
            "delay": 600 // ms
        }},
        {"Component": "OnSpawned", "Properties": {
            "OnSpawned": function() engine::PlaySound("get_points"); end function
        }}
    ]
},

{"Entity": "Points5000",
    "Components": [
        {"Component": "Location", "Properties": {
            "width": 0,
            "height": 0
        }},
        {"Component": "Velocity", "Properties": {
            "vx": 0,
            "vy": -40
        }},
        {"Component": "Visible", "Properties": {
            "lib": "sprites",
            "frame": "5000points",
            "layer": 3
        }},
        {"Component": "SelfDestructing", "Properties": {
            "delay": 600 // ms
        }},
        {"Component": "OnSpawned", "Properties": {
            "OnSpawned": function() engine::PlaySound("get_points"); end function
        }}
    ]
},

{"Entity": "CollectDrop",
    "Components": [
        {"Component": "Location", "Properties": {
            "width": 0,
            "height": 0
        }},
        {"Component": "Visible", "Properties": {
            "lib": "sprites",
            "frame": "drop5",
            "layer": 3
        }},
        {"Component": "Animation", "Properties": {
            "looped": true,
            "global": false,
            "delay": 315,
            "frames": ["drop5", "drop6", "drop7"]
        }},
        {"Component": "SelfDestructing", "Properties": {
            "delay": 315 // ms
        }},
        {"Component": "OnSpawned", "Properties": {
            "OnSpawned": function() engine::PlaySound("get_drop"); end function
        }}
    ]
},

{"Entity": "CollectGem",
    "Components": [
        {"Component": "Location", "Properties": {
            "width": 0,
            "height": 0
        }},
        {"Component": "Velocity", "Properties": {
            "vx": 0,
            "vy": -40
        }},
        {"Component": "Visible", "Properties": {
            "lib": "sprites",
            "frame": "gemgrab",
            "layer": 3
        }},
        {"Component": "SelfDestructing", "Properties": {
            "delay": 600 // ms
        }},
        {"Component": "OnSpawned", "Properties": {
            "OnSpawned": function() engine::PlaySound("get_gem"); end function
        }}
    ]
},

{"Entity": "CollectStunner",
    "Components": [
        {"Component": "Location", "Properties": {
            "width": 0,
            "height": 0
        }},
        {"Component": "Velocity", "Properties": {
            "vx": 0,
            "vy": -40
        }},
        {"Component": "Visible", "Properties": {
            "lib": "sprites",
            "frame": "gungrab",
            "layer": 3
        }},
        {"Component": "SelfDestructing", "Properties": {
            "delay": 600 // ms
        }},
        {"Component": "OnSpawned", "Properties": {
            "OnSpawned": function() engine::PlaySound("get_gun"); end function
        }}
    ]
},

{"Entity": "Blue1Up",
    "Components": [
        {"Component": "Location", "Properties": {
            "width": 0,
            "height": 0
        }},
        {"Component": "Velocity", "Properties": {
            "vx": 0,
            "vy": -40
        }},
        {"Component": "Visible", "Properties": {
            "lib": "sprites",
            "frame": "1up-blue",
            "layer": 3
        }},
        {"Component": "SelfDestructing", "Properties": {
            "delay": 600 // ms
        }}
    ]
},

{"Entity": "Yellow1Up",
    "Components": [
        {"Component": "Location", "Properties": {
            "width": 0,
            "height": 0
        }},
        {"Component": "Velocity", "Properties": {
            "vx": 0,
            "vy": -40
        }},
        {"Component": "Visible", "Properties": {
            "lib": "sprites",
            "frame": "1up-yellow",
            "layer": 3
        }},
        {"Component": "SelfDestructing", "Properties": {
            "delay": 600 // ms
        }},
        {"Component": "OnSpawned", "Properties": {
            "OnSpawned": function() engine::PlaySound("get_1up"); end function
        }}
    ]
},

// ********************************************************************************************** //
// * ENEMIES                                                                                    * //
// ********************************************************************************************** //

{"Entity": "Arachnut",
    "Components": [
        {"Component": "Location", "Properties": {
            "width": 40,
            "height": 40
        }},
        {"Component": "Collidable"},
        {"Component": "Velocity", "Properties": {
            "vxMax": 140,
            "vyMax": 380
        }},
        {"Component": "GravityClipped"},
        {"Component": "PhysicalPlatform"},
        {"Component": "Visible", "Properties": {
            "lib": "arachnut",
            "frame": "arachnut_run1",
            "layer": 2
        }},
        {"Component": "LethalToPlayer"},
        {"Component": "PlayerShotBlocker"},
        {"Component": "ArachnutAI"}
    ]
},

{"Entity": "Bounder",
    "Components": [
        {"Component": "Location", "Properties": {
            "width": 24,
            "height": 21
        }},
        {"Component": "Collidable"},
        {"Component": "Velocity", "Properties": {
            "vxMax": 140,
            "vyMax": 380
        }},
        {"Component": "GravityClipped"},
        {"Component": "PhysicalPlatform"},
        {"Component": "Visible", "Properties": {
            "lib": "bounder",
            "frame": "bounder_up1",
            "layer": 2
        }},
        {"Component": "PlayerShotBlocker"},
        {"Component": "BounderAI"}
    ]
},

{"Entity": "Cloud",
    "Components": [
        {"Component": "Location", "Properties": {
            "width": 64,
            "height": 24
        }},
        {"Component": "Collidable"},
        {"Component": "Velocity", "Properties": {
            "vxMax": 140,
            "vyMax": 380
        }},
        {"Component": "GravityClipped"},
        {"Component": "Visible", "Properties": {
            "lib": "cloud",
            "frame": "cloud_aware",
            "layer": 2
        }},
        {"Component": "CloudAI"}
    ]
},

{"Entity": "Inchworm",
    "Components": [
        {"Component": "Location", "Properties": {
            "width": 24,
            "height": 16
        }},
        {"Component": "Velocity", "Properties": {
            "vxMax": 140,
            "vyMax": 380
        }},
        {"Component": "GravityClipped"},
        {"Component": "PhysicalPlatform"},
        {"Component": "Visible", "Properties": {
            "lib": "inchworm",
            "frame": "inchworm_left1",
            "layer": 2
        }},
        {"Component": "InchwormAI"}
    ]
},

{"Entity": "Lick",
    "Components": [
        {"Component": "Location", "Properties": {
            "width": 22,
            "height": 16
        }},
        {"Component": "Collidable"},
        {"Component": "Velocity", "Properties": {
            "vxMax": 140,
            "vyMax": 380
        }},
        {"Component": "GravityClipped"},
        {"Component": "PhysicalPlatform"},
        {"Component": "Visible", "Properties": {
            "lib": "lick",
            "frame": "lick_left2",
            "layer": 2
        }},
        {"Component": "PlayerShotBlocker"},
        {"Component": "LickAI"}
    ]
},

{"Entity": "Mimrock",
    "Components": [
        {"Component": "Location", "Properties": {
            "width": 24,
            "height": 24
        }},
        {"Component": "Collidable"},
        {"Component": "Velocity", "Properties": {
            "vxMax": 140,
            "vyMax": 380
        }},
        {"Component": "GravityClipped"},
        {"Component": "PhysicalPlatform"},
        {"Component": "Visible", "Properties": {
            "lib": "mimrock",
            "frame": "mimrock_sit",
            "layer": 2
        }},
        {"Component": "MimrockAI"}
    ]
},

{"Entity": "Mushroom",
    "Components": [
        {"Component": "Location", "Properties": {
            "width": 32,
            "height": 32
        }},
        {"Component": "Collidable"},
        {"Component": "Velocity", "Properties": {
            "vxMax": 140,
            "vyMax": 380
        }},
        {"Component": "GravityClipped"},
        {"Component": "PhysicalPlatform"},
        {"Component": "Visible", "Properties": {
            "lib": "mushroom",
            "frame": "mushroom_left1",
            "layer": 2
        }},
        {"Component": "LethalToPlayer"},
        {"Component": "PlayerShotBlocker"},
        {"Component": "MushroomAI"}
    ]
},

{"Entity": "Slug",
    "Components": [
        {"Component": "Location", "Properties": {
            "width": 16,
            "height": 24
        }},
        {"Component": "Collidable"},
        {"Component": "Velocity", "Properties": {
            "vxMax": 140,
            "vyMax": 380
        }},
        {"Component": "GravityClipped"},
        {"Component": "PhysicalPlatform"},
        {"Component": "Visible", "Properties": {
            "lib": "slug",
            "frame": "slug_left1",
            "layer": 2
        }},
        {"Component": "LethalToPlayer"},
        {"Component": "PlayerShotBlocker"},
        {"Component": "SlugAI"}
    ]
},

{"Entity": "Snake",
    "Components": [
        {"Component": "Location", "Properties": {
            "width": 16,
            "height": 24
        }},
        {"Component": "Collidable"},
        {"Component": "Velocity", "Properties": {
            "vxMax": 140,
            "vyMax": 380
        }},
        {"Component": "GravityClipped"},
        {"Component": "PhysicalPlatform"},
        {"Component": "Visible", "Properties": {
            "lib": "snake",
            "frame": "snake_attack_left2",
            "layer": 2
        }},
        {"Component": "SnakeAI"}
    ]
},

// ********************************************************************************************** //
// * PROPS                                                                                      * //
// ********************************************************************************************** //

{"Entity": "Door",
    "Components": [
        {"Component": "Location", "Properties": {
            "width": 32,
            "height": 32
        }},
        {"Component": "Collidable"},
        {"Component": "Visible", "Properties": {
            "lib": "ked",
            "frame": "entity-door",
            "layer": 3,
            "editorOnly": true
        }},
        {"Component": "MessageScript", "Properties": {
            "handlers": {
                "Connect":
                    function(args : association)
                        this.attributes["destination"] := args["eid"];
                        this.attributes["connections"] := [this.attributes["destination"]];
                    end function,
                "ActivateAtWill":
                    function(args : association)
                        constant destination := this.attributes["destination"];
                        if engine::EntityExists(destination) then
                            engine::Send(args["eid"], "Teleport", {"fromX": this.x,        "fromY": this.y - 16,
                                                                   "toX":   destination.x, "toY":   destination.y});
                        end if;
                    end function
            }
        }}
    ],
    "Attributes": {
        "gridsnap": true,
        "resizable": true,
        "connections": [],          // set by the "Connect" message handler in the editor
        "destination": null         // set by the "Connect" message handler in the editor
    }
},

{"Entity": "Fence",
    "Components": [
        {"Component": "Location", "Properties": {
            "width": 16,
            "height": 16
        }},
        {"Component": "Visible", "Properties": {
            "lib": "ked",
            "frame": "entity-fence",
            "layer": 3,
            "editorOnly": true
        }},
        {"Component": "OnWorldLoaded", "Properties": {
            "OnWorldLoaded":
                // The Fence entity erases the middleground tile underneath itself and then self-
                // destructs after a specified level has been beaten. The level that triggers the
                // self-destruction is specified in attributes["world"].
                function()
                    if game::lastWin = this.attributes["world"] and game::lastWin != "" then
                        engine::SetTile(engine::MAP_MIDDLEGROUND, this.x, this.y, 0);
                        engine::Destroy(this);
                    end if;
                end function
        }}
    ],
    "Attributes": {
        "gridsnap": true,

        "world": "",
        "editorAttributes": ["world"]
    }
},

{"Entity": "Flag",
    "Components": [
        {"Component": "Location", "Properties": {
            "width": 16,
            "height": 16
        }},
        {"Component": "OnSpawned", "Properties": {
            // offset the flag from its final location by its flying distance
            "OnSpawned":
                function()
                    this.x -= 30;   // fly distance
                    this.y += 30;   //
                    engine::PlaySound("flag1");
                end function
        }},
        {"Component": "Velocity", "Properties": {
            "vx":  40,              // move 30 px in 750 ms
            "vy": -40               // move 30 px in 750 ms
        }},
        {"Component": "Visible", "Properties": {
            "lib": "sprites",
            "frame": "flag1",
            "layer": 2
        }},
        {"Component": "Animation", "Properties": {
            "looped": false,
            "duration": 1050,       // 1050 ms (150 ms/frame)
            "frames": [
                "flag_raise1",      // moving    0 ms
                "flag_raise2",      // moving    .
                "flag_raise3",      // moving    .
                "flag_raise4",      // moving    .
                "flag_raise5",      // moving    .
                "flag_raise6",      // stopped   750 ms
                "flag_raise7"       // stopped   900 ms
            ]
        }},
        {"Component": "TimerScript", "Properties": {
            "delay": 750,           // 750 ms fly time
            "OnExpired": function() engine::RemoveComponent(this, "Velocity"); end function
        }},
        {"Component": "SelfDestructing", "Properties": {
            "delay": 1050           // 1050 ms lifetime
        }},
        {"Component": "SpawnOnDestruct", "Properties": {
            "template": "FlagFlying"
        }}
    ]
},

{"Entity": "FlagFlying",
    "Components": [
        {"Component": "Location", "Properties": {
            "width": 16,
            "height": 16
        }},
        {"Component": "Visible", "Properties": {
            "lib": "sprites",
            "frame": "flag1",
            "layer": 2
        }},
        {"Component": "Animation", "Properties": {
            "looped": true,
            "delay": 150,
            "frames": ["flag1", "flag2", "flag3", "flag4"]
        }},
        {"Component": "OnSpawned", "Properties": {
            "OnSpawned": function() engine::PlaySound("flag2"); end function
        }}
    ]
},

{"Entity": "FlagSpawner",
    "Components": [
        {"Component": "Location", "Properties": {
            "width": 16,
            "height": 16
        }},
        {"Component": "Visible", "Properties": {
            "lib": "ked",
            "frame": "entity-flagspawner",
            "layer": 3,
            "editorOnly": true
        }},
        {"Component": "OnWorldLoaded", "Properties": {
            "OnWorldLoaded":
                // The FlagSpawner entity spawns a Flag underneath itself and then self-destructs
                // after a specified level has been beaten. The level that triggers the self-
                // destruction is specified in attributes["world"].
                function()
                    if game::lastWin = this.attributes["world"] and game::lastWin != "" then
                        engine::SpawnAt("Flag", this.x, this.y);
                        engine::Destroy(this);
                    end if;
                end function
        }}
    ],
    "Attributes": {
        "gridsnap": true,

        "world": "",
        "editorAttributes": ["world"]
    }
},

{"Entity": "LevelEntrance",
    "Components": [
        {"Component": "Location", "Properties": {
            "width": 32,
            "height": 32
        }},
        {"Component": "Collidable"},
        {"Component": "Visible", "Properties": {
            "lib": "ked",
            "frame": "entity-entrance",
            "layer": 3,
            "editorOnly": true
        }},
        {"Component": "MessageScript", "Properties": {
            "handlers": {
                "ActivateAtWill":
                    // Only enter the level when the entrance is activated and the level hasn't
                    // been beaten yet, or is replayable (e.g. the BWB Megarocket).
                    function()
                        if !(this.attributes["world"] in game::completed) or this.attributes["replayable"] then
                            engine::EnterLevel(this.attributes["world"]);
                        end if;
                    end function
            }
        }}
    ],
    "Attributes": {
        "resizable": true,
        "gridsnap": true,

        "world": "",
        "replayable": false,
        "editorAttributes": ["world", "replayable"]
    }
},

{"Entity": "LevelExit",
    "Components": [
        {"Component": "Location", "Properties": {
            "width": 32,
            "height": 32
        }},
        {"Component": "Collidable"},
        {"Component": "Visible", "Properties": {
            "lib": "ked",
            "frame": "entity-exit",
            "layer": 3,
            "editorOnly": true
        }},
        {"Component": "MessageScript", "Properties": {
            "handlers": {
                "ActivateOnTouch": function() engine::ExitLevel(); end function
            }
        }}
    ],
    "Attributes": {
        "resizable": true,
        "gridsnap": true
    }
},

{"Entity": "Pole",
    "Components": [
        {"Component": "Location", "Properties": {
            "width": 16,
            "height": 16
        }},
        {"Component": "Collidable"},
        {"Component": "Visible", "Properties": {
            "lib": "ked",
            "frame": "entity-pole",
            "layer": 3,
            "editorOnly": true
        }},
        {"Component": "Climbable"}
    ],
    "Attributes": {
        "resizable": true,
        "gridsnap": true
    }
},

{"Entity": "StunnerBlast",
    "Components": [
        {"Component": "Location", "Properties": {
            "width": 16,
            "height": 16
        }},
        {"Component": "Collidable"},
        {"Component": "Visible", "Properties": {
            "lib": "sprites",
            "frame": "phaze-blast1",
            "layer": 2
        }},
        {"Component": "Animation", "Properties": {
            "looped": false,
            "delay": 210,
            "frames": ["phaze-blast1", "phaze-blast2"]
        }},
        {"Component": "SelfDestructing", "Properties": {
            "delay": 210 // ms
        }},
        {"Component": "OnSpawned", "Properties": {
            "OnSpawned": function() engine::PlaySound("shot_hit"); end function
        }}
    ]
},

{"Entity": "StunnerShot",
    "Components": [
        {"Component": "Location", "Properties": {
            "width": 16,
            "height": 16
        }},
        {"Component": "Collidable"},
        {"Component": "Velocity", "Properties": {
            "vx": 0,                               // set at instantiation
            "vy": 0                                //
        }},
        {"Component": "ZeroGClipped"},
        {"Component": "Visible", "Properties": {
            "lib": "sprites",
            "frame": "phaze1",
            "layer": 2
        }},
        {"Component": "Animation", "Properties": {
            "looped": true,
            "delay": 115,
            "frames": ["phaze1", "phaze2", "phaze3", "phaze4"]
        }},
        {"Component": "Lethal", "Properties": {
            "victim": "Enemy"
        }},
        {"Component": "ShotAI", "Properties": {
            "shooter": "Player"
        }},
        {"Component": "SpawnOnDestruct", "Properties": {
            "template": "StunnerBlast"
        }}
    ]
},

{"Entity": "SwimMessage",
    "Components": [
        {"Component": "Location", "Properties": {
            "width": 32,
            "height": 32
        }},
        {"Component": "Collidable"},
        {"Component": "Visible", "Properties": {
            "lib": "ked",
            "frame": "entity-swimmessage",
            "layer": 3,
            "editorOnly": true
        }},
        {"Component": "MessageScript", "Properties": {
            "handlers": {
                "ActivateOnTouch":
                    function()
                        if (!game::scuba) then
                            engine::MessageBox("I can't swim!", "talking_keen", "left");
                            engine::PlaySound("no");
                        end if;
                    end function
            }
        }}
    ],
    "Attributes": {
        "resizable": true,
        "gridsnap": true
    }
}

]
